/*
 * port_init.h
 *
 * Created: 09.01.2015 09:31:00
 *  Author: Stanislav Chystiakov (DESY)
 */ 


#ifndef PORT_INIT_H_
#define PORT_INIT_H_

#define TOGGLE_PIN_OK 1
#define TOGGLE_PIN_ERR 0

#define PORT_B_SAFE_MASK 0x03
#define PORT_C_SAFE_MASK 0x08

// Masks for PINs PB0-PB1, PC3, PD0-PD7
#define PORT_B0			0x01
#define PORT_B1			0x02
#define MCULED_PIN		0x08	// MCU LED on pin PC3
#define PORT_D0			0x01
#define PORT_D1			0x02
#define PORT_D2			0x04
#define PORT_D3			0x08
#define PORT_D4			0x10
#define PORT_D5			0x20
#define PORT_D6			0x40
#define PORT_D7			0x80

#define _PORTB_			0x41	// transmit value for PORTB
#define _PORTD_			0x42	// transmit value for PORTD
#define _PORTC_			0x43	// transmit value for PORTC

void port_init(void);
char togglePin(char pinName, char pinNum);
void setPortDirection(uint8_t portName, uint8_t portDir);
void setPortLevel(uint8_t portName, uint8_t portLev);
uint8_t readPortLevel(uint8_t portName);


#endif /* PORT_INIT_H_ */