/*
* timer.c
*
* Created: 05.02.2015 08:01:50
*  Author: USER
*/
#include "timer.h"
#include "port_init.h"
#include "TWI_Slave.h"
#include "ADC.h"

int countsToError = COUNTS_TO_ERR; //
extern int adcDataBuf[3];
extern uint8_t samplesNum;

void timerConfig() {						//configure 16/bit Timer/Counter
	cli();									// interrupt disable during initialization
	TCCR1A = 0x00;
	//TCCR1B = (1 << CS11);					//clk/8 (From prescaler)
	TCCR1B = (1 << CS11) | (1 << CS10);		//clk/64 (From prescaler)
	OCR1A = UPDATE_TIME;					// set timer tick's
	TIMSK1 = 1 << OCIE1A;					//Timer/Counter1, Output Compare A Match Interrupt Enable
	TCNT1 = 0;								// timer reset
	sei();									// interrupt enable after initialization
}


//Timer 250ms now! 
ISR (TIMER1_COMPA_vect) {					//TimerCounter0 Compare Match A
	unsigned char adcChannel;
	TCNT1 = 0;
	//togglePin('B', PORT_B1);
	
	if ((countsToError > 0) && (countsToError <= COUNTS_TO_ERR)) // Watch Dog
	{
		countsToError--;
		PORTC |= MCULED_PIN;		// MCULED_PIN is HIGH --> MCULED off
	} 
	else
	{
		PORTC &= ~MCULED_PIN;		// MCULED_PIN is LOW --> MCULED on
		TWI_Start_Transceiver();	// Needed to restart TWI bus after FuseRelayBoard-uC reprogram/reload
	}	
	
	for (adcChannel = 0; adcChannel < 3; adcChannel++)
	{
		adcDataBuf[adcChannel] = ADC_result_average(adcChannel);
	}	
}