/**
 * \file
 *
 * \brief User board initialization template
 *
 */

#include <asf.h>
#include <board.h>
#include <conf_board.h>
#include <ioport.h>


void board_init(void)
{
	ioport_configure_pin(MMC_LED, IOPORT_DIR_OUTPUT);
	
	ioport_configure_pin(LOCAL_I2C_SCL_ERR, IOPORT_DIR_INPUT);
	ioport_configure_pin(LOCAL_I2C_SDA_ERR, IOPORT_DIR_INPUT);
	
	ioport_configure_pin(LOCAL_I2C_SCL, IOPORT_MODE_WIREDANDPULL);
	ioport_configure_pin(LOCAL_I2C_SDA, IOPORT_MODE_WIREDANDPULL);
	
	//USART	
	ioport_configure_pin(SUART_TX, IOPORT_DIR_OUTPUT | IOPORT_INIT_HIGH);
	ioport_configure_pin(SUART_RX, IOPORT_DIR_INPUT);
	
	//CPLD parallel bus
	ioport_configure_pin(CPLD_ADDR0, IOPORT_DIR_OUTPUT);
	ioport_configure_pin(CPLD_ADDR1, IOPORT_DIR_OUTPUT);
	ioport_configure_pin(CPLD_ADDR2, IOPORT_DIR_OUTPUT);
	ioport_configure_pin(CPLD_ADDR3, IOPORT_DIR_OUTPUT);
	ioport_configure_pin(CPLD_ADDR4, IOPORT_DIR_OUTPUT);
	
	ioport_configure_pin(CPLD_READ,  IOPORT_DIR_OUTPUT | IOPORT_INIT_HIGH);
	ioport_configure_pin(CPLD_CLOCK, IOPORT_DIR_OUTPUT | IOPORT_INIT_LOW);
	//ioport_configure_pin(CPLD_WRITE, IOPORT_DIR_OUTPUT | IOPORT_INIT_HIGH);
	
	ioport_configure_pin(CPLD_DATA0, IOPORT_DIR_INPUT);
	ioport_configure_pin(CPLD_DATA1, IOPORT_DIR_INPUT);
	ioport_configure_pin(CPLD_DATA2, IOPORT_DIR_INPUT);
	ioport_configure_pin(CPLD_DATA3, IOPORT_DIR_INPUT);


	ioport_configure_pin(ON_OFF_FLIP_FLOP, IOPORT_DIR_INPUT);
}
