﻿/*
 * bootloader.h
 *
 * Created: 2015-04-12 13:07:31
 *  Author: Paweł
 */ 


#ifndef BOOTLOADER_H_
#define BOOTLOADER_H_

#include <stdbool.h>
#include <stdint.h>

typedef enum {INIT, HANDSHAKE, DATA, FINISH} BootloaderState;

#define BOOTLDR_ESCAPE 0x01	
#define BOOTLDR_HANDSHAKE 0x02
#define BOOTLDR_DATA 0x03
#define BOOTLDR_FINISH 0x04
#define BOOTLDR_RESET 0x05

#define BOOTLDR_RES_OK 0x01
#define BOOTLDR_RES_FAIL 0x02
#define BOOTLDR_RES_ABORT 0x03

#define BOOTLDR_ERR_MAX 20


#define EEPROM_ADDR_FWUPGRADE (uint8_t *) 63
#define EEPROM_FWUPGRADE_VALUE			(uint8_t)   0x56
#define EEPROM_FWREADY_VALUE			(uint8_t)  0x55

void start_bootloader(void);
void start_firmware(void);
void eeprom_write_upgrade(void);
void eeprom_write_ready(void);
bool eeprom_read_upgrade(void);
void checksum_add_byte(uint8_t byte);
bool read_compare_checksum(void);

#endif /* BOOTLOADER_H_ */