﻿/*
 * eeprom.c
 *
 * Created: 2015-04-14 14:13:22
 *  Author: Paweł
 */ 
#include "eeprom.h"
#include <avr/eeprom.h>
#include <util/delay.h>

void initEEPROM( void )
{
	if (eeprom_read_byte(EEPROM_ADDR_INIT) != EEPROM_INIT_VALUE)
	{
		eeprom_write_byte(EEPROM_ADDR_LIMIT_MASK, 0xFF);
		eeprom_write_dword(EEPROM_ADDR_LIMIT_CHANNEL0, 10000);
		eeprom_write_dword(EEPROM_ADDR_LIMIT_CHANNEL1, 10000);
		eeprom_write_dword(EEPROM_ADDR_LIMIT_CHANNEL2, 10000);
		eeprom_write_dword(EEPROM_ADDR_LIMIT_CHANNEL3, 10000);
		eeprom_write_dword(EEPROM_ADDR_LIMIT_CHANNEL4, 10000);
		eeprom_write_dword(EEPROM_ADDR_LIMIT_CHANNEL5, 10000);
		eeprom_write_dword(EEPROM_ADDR_LIMIT_CHANNEL6, 10000);
		eeprom_write_dword(EEPROM_ADDR_LIMIT_CHANNEL7, 10000);
		eeprom_write_byte(EEPROM_ADDR_FWUPGRADE, EEPROM_FWREADY_VALUE);
		eeprom_write_byte(EEPROM_ADDR_INIT, EEPROM_INIT_VALUE);
		eeprom_write_name("FRED 3M standard");
		eeprom_write_inv_no("0000");
	}
	if(eeprom_read_byte(EEPROM_ADDR_FWUPGRADE) != EEPROM_FWREADY_VALUE)
	{
		eeprom_write_byte(EEPROM_ADDR_FWUPGRADE, EEPROM_FWREADY_VALUE);
	}
}

void eeprom_write_upgrade(void)
{
	eeprom_write_byte(EEPROM_ADDR_FWUPGRADE, EEPROM_FWUPGRADE_VALUE);	
	_delay_ms(100);
}

void eeprom_write_name( char * name )
{
	int i = 0;
	for (i = 0; i < EEPROM_STR_LEN; i++)
	{
		if (name[i] != '\0')
			eeprom_write_byte(EEPROM_ADDR_BOARD_NAME + i, name[i]);
		else 
			break;
	}
	eeprom_write_byte(EEPROM_ADDR_BOARD_NAME + i, name[i]);
}

void eeprom_write_inv_no( char * number )
{
	int i = 0;
	for (i = 0; i < EEPROM_STR_LEN; i++)
	{
		if (number[i] != '\0')
			eeprom_write_byte(EEPROM_ADDR_INV_NO + i, number[i]);
		else 
			break;
	}
	eeprom_write_byte(EEPROM_ADDR_INV_NO + i, number[i]);	
}

void eeprom_read_name(char * name)
{
	int i = 0;
	char c;
	while ((c = eeprom_read_byte(EEPROM_ADDR_BOARD_NAME + i)) != '\0')
	{
		name[i] = c;
		i++;
	}
	name[i] = '\0';
}

void eeprom_read_inv_no(char * nr)
{
	int i = 0;
	char c;
	while ((c = eeprom_read_byte(EEPROM_ADDR_INV_NO + i)) != '\0')
	{
		nr[i] = c;
		i++;
	}
	nr[i] = '\0';	
}