﻿/*
 * eeprom.h
 *
 * Created: 2015-04-14 14:13:10
 *  Author: Paweł
 */ 


#ifndef EEPROM_H_
#define EEPROM_H_

#define EEPROM_INIT_VALUE (uint8_t) 0x55

#define EEPROM_ADDR_INIT			(uint8_t *)  0
#define EEPROM_ADDR_LIMIT_MASK		(uint8_t *)  1
#define EEPROM_ADDR_LIMIT_CHANNEL0	(uint32_t *) 4
#define EEPROM_ADDR_LIMIT_CHANNEL1	(uint32_t *) 8
#define EEPROM_ADDR_LIMIT_CHANNEL2	(uint32_t *) 12
#define EEPROM_ADDR_LIMIT_CHANNEL3	(uint32_t *) 16
#define EEPROM_ADDR_LIMIT_CHANNEL4	(uint32_t *) 20
#define EEPROM_ADDR_LIMIT_CHANNEL5	(uint32_t *) 24
#define EEPROM_ADDR_LIMIT_CHANNEL6	(uint32_t *) 28
#define EEPROM_ADDR_LIMIT_CHANNEL7	(uint32_t *) 32
#define EEPROM_ADDR_FWUPGRADE		(uint8_t *)  63
#define EEPROM_ADDR_BOARD_NAME		(uint8_t *)	 100
#define EEPROM_ADDR_INV_NO			(uint8_t *)	 200

#define EEPROM_FWUPGRADE_VALUE		(uint8_t) 0x56
#define EEPROM_FWREADY_VALUE		(uint8_t) 0x55
#define EEPROM_STR_LEN				64

void initEEPROM(void);
void eeprom_write_upgrade(void);

void eeprom_write_name(char * name);
void eeprom_write_inv_no(char * number);
void eeprom_read_name(char * name);
void eeprom_read_inv_no(char * nr);
#endif /* EEPROM_H_ */