﻿/*
 * IncFile1.h
 *
 * Created: 2014-02-08 17:50:20
 *  Author: Michael Fenner
 */ 


#ifndef FAN_LIB_H_
#define FAN_LIB_H_
#include <stdbool.h>

#define FAN_COUNT				3
#define FANCTRL_ADDR			0x3E >> 1
#define FANREG_SPEED			0x00
#define FANREG_CONFIG			0x02
#define  FANCONFIG_FULLON		0x00
#define  FANCONFIG_SOFTWAREOFF  0x01
#define  FANCONFIG_CLOSEDLOOP	0x02
#define  FANCONFIG_OPENLOOP	    0x03
#define  FANCONFIG_TACH5V		0x00
#define  FANCONFIG_TACH12V		0x01
#define  FANCONFIG_DIV1		    0x00
#define  FANCONFIG_DIV2		    0x01
#define  FANCONFIG_DIV4		    0x02
#define  FANCONFIG_DIV8		    0x03
#define  FANCONFIG_DIV16		0x04
#define FANREG_GPIODEF			0x04
#define  FANGPIO4_LOW			0x00
#define  FANGPIO4_HIGH			0x80
#define  FANGPIO3_LOW			0x00
#define  FANGPIO3_HIGH			0x40
#define  FANGPIO2_EXTCLK		0x00
#define  FANGPIO2_INTCLK		0x10
#define  FANGPIO2_LOW			0x20
#define  FANGPIO2_HIGH			0x30
#define  FANGPIO1_FULLONIN		0x04
#define  FANGPIO1_LOW			0x08
#define  FANGPIO1_HIGH			0x0C
#define  FANGPIO0_ALERTOUT		0x01
#define  FANGPIO0_LOW			0x02
#define  FANGPIO0_HIGH			0x03
#define FANREG_DAC				0x06
#define FANREG_ALARMENABLE		0x08
#define  FANALARM_GPIO2			0x10
#define  FANALARM_GPIO1			0x08
#define  FANALARM_TACH			0x04
#define  FANALARM_MIN			0x02
#define  FANALARM_MAX			0x01    			
#define FANREG_ALARM			0x0A
#define FANREG_TACH0			0x0C
#define FANREG_TACH1			0x0E
#define FANREG_TACH2			0x10
#define FANREG_TACH3			0x12
#define FANREG_GPIOSTAT			0x14
#define FANREG_COUNT			0x16
#define  FANCOUNT_0_25			0x00
#define  FANCOUNT_0_5			0x01
#define  FANCOUNT_1_0			0x02
#define  FANCOUNT_2_0			0x03

#define FAN_DAC_MAX				0xFF

extern unsigned fan_target_rpm[FAN_COUNT];

int fan_CheckPresence(void);
void fan_init(void);
void setFanSpeed(uint8_t spdRange);
void setFanSpeedRpm(uint16_t rpm);
int readFansSpeedRpm(uint8_t fan, unsigned *value);
int setOperatingMode(uint8_t mode);
uint8_t readFanAlarmStatusReg(uint8_t *value);
uint8_t rconfreg(void);
void printFanInfoHeader(void);
void printFanInfo(uint8_t fan);
int readOperatingMode(uint8_t *mode);
#endif 